gnunet-svn
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

[taler-wallet-core] 06/06: integration tests (based on Christian's audit


From: gnunet
Subject: [taler-wallet-core] 06/06: integration tests (based on Christian's auditor tests)
Date: Mon, 06 Apr 2020 10:46:02 +0200

This is an automated email from the git hooks/post-receive script.

dold pushed a commit to branch master
in repository wallet-core.

commit 13bccc7bd982da58738dfd63a2493e476d596161
Author: Florian Dold <address@hidden>
AuthorDate: Mon Apr 6 14:15:49 2020 +0530

    integration tests (based on Christian's auditor tests)
---
 integrationtests/.gitignore     |   3 +
 integrationtests/template.conf  | 224 +++++++++++++++++++++++++++++
 integrationtests/test-base.sh   | 137 ++++++++++++++++++
 integrationtests/test-recoup.sh | 302 ++++++++++++++++++++++++++++++++++++++++
 4 files changed, 666 insertions(+)

diff --git a/integrationtests/.gitignore b/integrationtests/.gitignore
new file mode 100644
index 00000000..447e2f32
--- /dev/null
+++ b/integrationtests/.gitignore
@@ -0,0 +1,3 @@
+*.log
+*-prod.conf
+*.wallet.json
diff --git a/integrationtests/template.conf b/integrationtests/template.conf
new file mode 100644
index 00000000..99721d3d
--- /dev/null
+++ b/integrationtests/template.conf
@@ -0,0 +1,224 @@
+[exchange]
+KEYDIR = ${TALER_DATA_HOME}/exchange/live-keys/
+REVOCATION_DIR = ${TALER_DATA_HOME}/exchange/revocations/
+MAX_KEYS_CACHING = forever
+DB = postgres
+MASTER_PRIV_FILE = ${TALER_DATA_HOME}/exchange/offline-keys/master.priv
+SERVE = tcp
+UNIXPATH = ${TALER_RUNTIME_DIR}/exchange.http
+UNIXPATH_MODE = 660
+PORT = 8081
+BASE_URL = http://localhost:8081/
+SIGNKEY_DURATION = 4 weeks
+LEGAL_DURATION = 2 years
+LOOKAHEAD_SIGN = 32 weeks 1 day
+LOOKAHEAD_PROVIDE = 4 weeks 1 day
+
+[merchant]
+SERVE = tcp
+PORT = 9966
+UNIXPATH = ${TALER_RUNTIME_DIR}/merchant.http
+UNIXPATH_MODE = 660
+DEFAULT_WIRE_FEE_AMORTIZATION = 1
+DB = postgres
+WIREFORMAT = default
+# Set very low, so we can be sure that the database generated
+# will contain wire transfers "ready" for the aggregator.
+WIRE_TRANSFER_DELAY = 1 minute
+DEFAULT_PAY_DEADLINE = 1 day
+DEFAULT_MAX_DEPOSIT_FEE = TESTKUDOS:0.1
+KEYFILE = ${TALER_DATA_HOME}/merchant/merchant.priv
+DEFAULT_MAX_WIRE_FEE = TESTKUDOS:0.10
+
+# Ensure that merchant reports EVERY deposit confirmation to auditor
+FORCE_AUDIT = YES
+
+[instance-default]
+KEYFILE = ${TALER_DATA_HOME}/merchant/default.priv
+NAME = Merchant Inc.
+
+[auditor]
+DB = postgres
+AUDITOR_PRIV_FILE = ${TALER_DATA_HOME}/auditor/offline-keys/auditor.priv
+SERVE = tcp
+UNIXPATH = ${TALER_RUNTIME_DIR}/exchange.http
+UNIXPATH_MODE = 660
+PORT = 8083
+AUDITOR_URL = http://localhost:8083/
+TINY_AMOUNT = TESTKUDOS:0.01
+
+[PATHS]
+TALER_HOME = ${PWD}/generate_auditordb_home/
+TALER_DATA_HOME = $TALER_HOME/.local/share/taler/
+TALER_CONFIG_HOME = $TALER_HOME/.config/taler/
+TALER_CACHE_HOME = $TALER_HOME/.cache/taler/
+TALER_RUNTIME_DIR = ${TMPDIR:-${TMP:-/tmp}}/taler-system-runtime/
+
+[bank]
+DATABASE = postgres:///taler-auditor-basedb
+MAX_DEBT = TESTKUDOS:50.0
+MAX_DEBT_BANK = TESTKUDOS:100000.0
+HTTP_PORT = 8082
+SUGGESTED_EXCHANGE = http://localhost:8081/
+SUGGESTED_EXCHANGE_PAYTO = payto://x-taler-bank/localhost/2
+ALLOW_REGISTRATIONS = YES
+
+[exchangedb]
+AUDITOR_BASE_DIR = ${TALER_DATA_HOME}/auditors/
+WIREFEE_BASE_DIR = ${TALER_DATA_HOME}/exchange/wirefees/
+IDLE_RESERVE_EXPIRATION_TIME = 4 weeks
+LEGAL_RESERVE_EXPIRATION_TIME = 7 years
+
+[exchange_keys]
+signkey_duration = 4 weeks
+legal_duration = 2 years
+lookahead_sign = 32 weeks 1 day
+lookahead_provide = 4 weeks 1 day
+
+[taler]
+CURRENCY = TESTKUDOS
+CURRENCY_ROUND_UNIT = TESTKUDOS:0.01
+
+[exchange-account-1]
+WIRE_RESPONSE = ${TALER_DATA_HOME}/exchange/account-1.json
+PAYTO_URI = payto://x-taler-bank/localhost/Exchange
+enable_debit = yes
+enable_credit = yes
+WIRE_GATEWAY_URL = "http://localhost:8082/taler-wire-gateway/Exchange/";
+WIRE_GATEWAY_AUTH_METHOD = basic
+USERNAME = Exchange
+PASSWORD = x
+
+[merchant-account-merchant]
+PAYTO_URI = payto://x-taler-bank/localhost/42
+WIRE_RESPONSE = ${TALER_CONFIG_HOME}/merchant/account-3.json
+HONOR_default = YES
+ACTIVE_default = YES
+
+[fees-x-taler-bank]
+wire-fee-2020 = TESTKUDOS:0.01
+closing-fee-2020 = TESTKUDOS:0.01
+wire-fee-2021 = TESTKUDOS:0.01
+closing-fee-2021 = TESTKUDOS:0.01
+wire-fee-2022 = TESTKUDOS:0.01
+closing-fee-2022 = TESTKUDOS:0.01
+wire-fee-2023 = TESTKUDOS:0.01
+closing-fee-2023 = TESTKUDOS:0.01
+wire-fee-2024 = TESTKUDOS:0.01
+closing-fee-2024 = TESTKUDOS:0.01
+wire-fee-2025 = TESTKUDOS:0.01
+closing-fee-2025 = TESTKUDOS:0.01
+wire-fee-2026 = TESTKUDOS:0.01
+closing-fee-2026 = TESTKUDOS:0.01
+wire-fee-2027 = TESTKUDOS:0.01
+closing-fee-2027 = TESTKUDOS:0.01
+wire-fee-2028 = TESTKUDOS:0.01
+closing-fee-2028 = TESTKUDOS:0.01
+
+[merchant-instance-wireformat-default]
+TEST_RESPONSE_FILE = ${TALER_CONFIG_HOME}/merchant/wire/tutorial.json
+
+[merchant-exchange-default]
+EXCHANGE_BASE_URL = http://localhost:8081/
+CURRENCY = TESTKUDOS
+
+[payments-generator]
+currency = TESTKUDOS
+instance = default
+bank = http://localhost:8082/
+merchant = http://localhost:9966/
+exchange_admin = http://localhost:18080/
+exchange-admin = http://localhost:18080/
+exchange = http://localhost:8081/
+
+[coin_kudos_ct_1]
+value = TESTKUDOS:0.01
+duration_withdraw = 7 days
+duration_spend = 2 years
+duration_legal = 3 years
+fee_withdraw = TESTKUDOS:0.01
+fee_deposit = TESTKUDOS:0.01
+fee_refresh = TESTKUDOS:0.01
+fee_refund = TESTKUDOS:0.01
+rsa_keysize = 1024
+
+[coin_kudos_ct_10]
+value = TESTKUDOS:0.10
+duration_withdraw = 7 days
+duration_spend = 2 years
+duration_legal = 3 years
+fee_withdraw = TESTKUDOS:0.01
+fee_deposit = TESTKUDOS:0.01
+fee_refresh = TESTKUDOS:0.03
+fee_refund = TESTKUDOS:0.01
+rsa_keysize = 1024
+
+[coin_kudos_1]
+value = TESTKUDOS:1
+duration_withdraw = 7 days
+duration_spend = 2 years
+duration_legal = 3 years
+fee_withdraw = TESTKUDOS:0.02
+fee_deposit = TESTKUDOS:0.02
+fee_refresh = TESTKUDOS:0.03
+fee_refund = TESTKUDOS:0.01
+rsa_keysize = 1024
+
+[coin_kudos_2]
+value = TESTKUDOS:2
+duration_withdraw = 7 days
+duration_spend = 2 years
+duration_legal = 3 years
+fee_withdraw = TESTKUDOS:0.03
+fee_deposit = TESTKUDOS:0.03
+fee_refresh = TESTKUDOS:0.04
+fee_refund = TESTKUDOS:0.02
+rsa_keysize = 1024
+
+[coin_kudos_4]
+value = TESTKUDOS:4
+duration_withdraw = 7 days
+duration_spend = 2 years
+duration_legal = 3 years
+fee_withdraw = TESTKUDOS:0.03
+fee_deposit = TESTKUDOS:0.03
+fee_refresh = TESTKUDOS:0.04
+fee_refund = TESTKUDOS:0.02
+rsa_keysize = 1024
+
+[coin_kudos_5]
+value = TESTKUDOS:5
+duration_withdraw = 7 days
+duration_spend = 2 years
+duration_legal = 3 years
+fee_withdraw = TESTKUDOS:0.01
+fee_deposit = TESTKUDOS:0.01
+fee_refresh = TESTKUDOS:0.03
+fee_refund = TESTKUDOS:0.01
+rsa_keysize = 1024
+
+[coin_kudos_8]
+value = TESTKUDOS:8
+duration_withdraw = 7 days
+duration_spend = 2 years
+duration_legal = 3 years
+fee_withdraw = TESTKUDOS:0.05
+fee_deposit = TESTKUDOS:0.02
+fee_refresh = TESTKUDOS:0.03
+fee_refund = TESTKUDOS:0.04
+rsa_keysize = 1024
+
+[coin_kudos_10]
+value = TESTKUDOS:10
+duration_withdraw = 7 days
+duration_spend = 2 years
+duration_legal = 3 years
+fee_withdraw = TESTKUDOS:0.01
+fee_deposit = TESTKUDOS:0.01
+fee_refresh = TESTKUDOS:0.03
+fee_refund = TESTKUDOS:0.01
+rsa_keysize = 1024
+
+[benchmark]
+BANK_DETAILS = bank_details.json
+MERCHANT_DETAILS = merchant_details.json
diff --git a/integrationtests/test-base.sh b/integrationtests/test-base.sh
new file mode 100755
index 00000000..044ea037
--- /dev/null
+++ b/integrationtests/test-base.sh
@@ -0,0 +1,137 @@
+#!/bin/bash
+# Script to generate the basic database for auditor
+# testing from a 'correct' interaction between exchange,
+# wallet and merchant.
+
+
+set -eu
+
+trap "kill `jobs -p` &> /dev/null || true" ERR
+trap "kill `jobs -p` &> /dev/null || true" EXIT
+
+# Exit, with status code "skip" (no 'real' failure)
+function exit_skip() {
+    echo $1
+    exit 77
+}
+
+# Where do we write the result?
+BASEDB=${1:-"auditor-basedb"}
+
+# Name of the Postgres database we will use for the script.
+# Will be dropped, do NOT use anything that might be used
+# elsewhere
+TARGET_DB=taler-auditor-basedb
+
+# Configuration file will be edited, so we create one
+# from the template.
+CONF=test-base.conf
+cp template.conf $CONF
+
+
+echo -n "Testing for taler-bank-manage"
+taler-bank-manage -h >/dev/null </dev/null || exit_skip " MISSING"
+echo " FOUND"
+echo -n "Testing for taler-wallet-cli"
+taler-wallet-cli -v >/dev/null </dev/null || exit_skip " MISSING"
+echo " FOUND"
+
+
+
+# Clean up
+DATA_DIR=`taler-config -f -c $CONF -s PATHS -o TALER_HOME`
+rm -rf $DATA_DIR || true
+
+# reset database
+dropdb $TARGET_DB >/dev/null 2>/dev/null || true
+createdb $TARGET_DB || exit_skip "Could not create database $TARGET_DB"
+
+# obtain key configuration data
+MASTER_PRIV_FILE=`taler-config -f -c $CONF -s EXCHANGE -o MASTER_PRIV_FILE`
+MASTER_PRIV_DIR=`dirname $MASTER_PRIV_FILE`
+mkdir -p $MASTER_PRIV_DIR
+gnunet-ecc -g1 $MASTER_PRIV_FILE > /dev/null
+MASTER_PUB=`gnunet-ecc -p $MASTER_PRIV_FILE`
+EXCHANGE_URL=`taler-config -c $CONF -s EXCHANGE -o BASE_URL`
+MERCHANT_PORT=`taler-config -c $CONF -s MERCHANT -o PORT`
+MERCHANT_URL=http://localhost:${MERCHANT_PORT}/
+BANK_PORT=`taler-config -c $CONF -s BANK -o HTTP_PORT`
+BANK_URL=http://localhost:${BANK_PORT}/
+AUDITOR_URL=http://localhost:8083/
+
+# patch configuration
+taler-config -c $CONF -s exchange -o MASTER_PUBLIC_KEY -V $MASTER_PUB
+taler-config -c $CONF -s merchant-exchange-default -o MASTER_KEY -V $MASTER_PUB
+taler-config -c $CONF -s exchangedb-postgres -o CONFIG -V 
postgres:///$TARGET_DB
+taler-config -c $CONF -s auditordb-postgres -o CONFIG -V postgres:///$TARGET_DB
+taler-config -c $CONF -s merchantdb-postgres -o CONFIG -V 
postgres:///$TARGET_DB
+taler-config -c $CONF -s bank -o database -V postgres:///$TARGET_DB
+
+# setup exchange
+echo "Setting up exchange"
+taler-exchange-dbinit -c $CONF
+taler-exchange-wire -c $CONF 2> taler-exchange-wire.log
+taler-exchange-keyup -L INFO -c $CONF -o e2a.dat 2> taler-exchange-keyup.log
+
+# setup auditor
+echo "Setting up auditor"
+taler-auditor-dbinit -c $CONF
+taler-auditor-exchange -c $CONF -m $MASTER_PUB -u $EXCHANGE_URL
+taler-auditor-sign -c $CONF -u $AUDITOR_URL -r e2a.dat -o a2e.dat -m 
$MASTER_PUB
+rm -f e2a.dat
+
+# provide auditor's signature to exchange
+ABD=`taler-config -c $CONF -s EXCHANGEDB -o AUDITOR_BASE_DIR -f`
+mkdir -p $ABD
+mv a2e.dat $ABD
+
+# Launch services
+echo "Launching services"
+taler-bank-manage-testing $CONF postgres:///$TARGET_DB serve-http &
+taler-exchange-httpd -c $CONF 2> taler-exchange-httpd.log &
+taler-merchant-httpd -c $CONF -L INFO 2> taler-merchant-httpd.log &
+taler-exchange-wirewatch -c $CONF 2> taler-exchange-wirewatch.log &
+taler-auditor-httpd -c $CONF 2> taler-auditor-httpd.log &
+
+# Wait for all services to be available
+for n in `seq 1 50`
+do
+    echo -n "."
+    sleep 0.1
+    OK=0
+    # exchange
+    wget http://localhost:8081/ -o /dev/null -O /dev/null >/dev/null || 
continue
+    # merchant
+    wget http://localhost:9966/ -o /dev/null -O /dev/null >/dev/null || 
continue
+    # bank
+    wget http://localhost:8082/ -o /dev/null -O /dev/null >/dev/null || 
continue
+    # Auditor
+    wget http://localhost:8083/ -o /dev/null -O /dev/null >/dev/null || 
continue
+    OK=1
+    break
+done
+
+if [ 1 != $OK ]
+then
+    kill `jobs -p`
+    wait
+    exit_skip "Failed to launch services"
+fi
+echo " DONE"
+
+# run wallet CLI
+echo "Running wallet"
+taler-wallet-cli testing integrationtest -e $EXCHANGE_URL -m $MERCHANT_URL -b 
$BANK_URL
+
+echo "Shutting down services"
+kill `jobs -p`
+wait
+
+# clean up
+echo "Final clean up"
+dropdb $TARGET_DB
+
+rm -rf $DATA_DIR || true
+rm $CONF
+
+exit 0
diff --git a/integrationtests/test-recoup.sh b/integrationtests/test-recoup.sh
new file mode 100755
index 00000000..198e1a19
--- /dev/null
+++ b/integrationtests/test-recoup.sh
@@ -0,0 +1,302 @@
+#!/bin/bash
+# Script to test revocation.
+#
+# Requires the wallet CLI to be installed and in the path.  Furthermore, the
+# user running this script must be Postgres superuser and be allowed to
+# create/drop databases.
+
+set -eu
+
+trap "kill `jobs -p` &> /dev/null || true" ERR
+trap "kill `jobs -p` &> /dev/null || true" EXIT
+
+# Exit, with status code "skip" (no 'real' failure)
+function exit_skip() {
+    echo $1
+    exit 77
+}
+
+# Where do we write the result?
+export BASEDB=${1:-"revoke-basedb"}
+
+# Name of the Postgres database we will use for the script.
+# Will be dropped, do NOT use anything that might be used
+# elsewhere
+export TARGET_DB=taler-auditor-revokedb
+TMP_DIR=`mktemp -d revocation-tmp-XXXXXX`
+export WALLET_DB=wallet-revocation.wallet.json
+rm -f $WALLET_DB
+
+# Configuration file will be edited, so we create one
+# from the template.
+export CONF=test-recoup.conf
+cp template.conf $CONF
+
+
+echo -n "Testing for taler-bank-manage"
+taler-bank-manage -h >/dev/null </dev/null || exit_skip " MISSING"
+echo " FOUND"
+echo -n "Testing for taler-wallet-cli"
+taler-wallet-cli -v >/dev/null </dev/null || exit_skip " MISSING"
+echo " FOUND"
+
+
+
+# Clean up
+DATA_DIR=`taler-config -f -c $CONF -s PATHS -o TALER_HOME`
+rm -rf $DATA_DIR || true
+
+# reset database
+dropdb $TARGET_DB >/dev/null 2>/dev/null || true
+createdb $TARGET_DB || exit_skip "Could not create database $TARGET_DB"
+
+# obtain key configuration data
+MASTER_PRIV_FILE=`taler-config -f -c $CONF -s EXCHANGE -o MASTER_PRIV_FILE`
+MASTER_PRIV_DIR=`dirname $MASTER_PRIV_FILE`
+mkdir -p $MASTER_PRIV_DIR
+gnunet-ecc -g1 $MASTER_PRIV_FILE > /dev/null
+export MASTER_PUB=`gnunet-ecc -p $MASTER_PRIV_FILE`
+export EXCHANGE_URL=`taler-config -c $CONF -s EXCHANGE -o BASE_URL`
+MERCHANT_PORT=`taler-config -c $CONF -s MERCHANT -o PORT`
+export MERCHANT_URL=http://localhost:${MERCHANT_PORT}/
+BANK_PORT=`taler-config -c $CONF -s BANK -o HTTP_PORT`
+export BANK_URL=http://localhost:${BANK_PORT}/
+export AUDITOR_URL=http://localhost:8083/
+
+# patch configuration
+taler-config -c $CONF -s exchange -o MASTER_PUBLIC_KEY -V $MASTER_PUB
+taler-config -c $CONF -s merchant-exchange-default -o MASTER_KEY -V $MASTER_PUB
+taler-config -c $CONF -s exchangedb-postgres -o CONFIG -V 
postgres:///$TARGET_DB
+taler-config -c $CONF -s auditordb-postgres -o CONFIG -V postgres:///$TARGET_DB
+taler-config -c $CONF -s merchantdb-postgres -o CONFIG -V 
postgres:///$TARGET_DB
+taler-config -c $CONF -s bank -o database -V postgres:///$TARGET_DB
+taler-config -c $CONF -s exchange -o KEYDIR -V "${TMP_DIR}/keydir/"
+taler-config -c $CONF -s exchange -o REVOCATION_DIR -V "${TMP_DIR}/revdir/"
+
+# setup exchange
+echo "Setting up exchange"
+taler-exchange-dbinit -c $CONF
+taler-exchange-wire -c $CONF 2> taler-exchange-wire.log
+taler-exchange-keyup -L INFO -c $CONF -o e2a.dat 2> taler-exchange-keyup.log
+
+# setup auditor
+echo "Setting up auditor"
+taler-auditor-dbinit -c $CONF
+taler-auditor-exchange -c $CONF -m $MASTER_PUB -u $EXCHANGE_URL
+taler-auditor-sign -c $CONF -u $AUDITOR_URL -r e2a.dat -o a2e.dat -m 
$MASTER_PUB
+rm -f e2a.dat
+
+# provide auditor's signature to exchange
+ABD=`taler-config -c $CONF -s EXCHANGEDB -o AUDITOR_BASE_DIR -f`
+mkdir -p $ABD
+mv a2e.dat $ABD
+
+# Launch services
+echo "Launching services"
+taler-bank-manage-testing $CONF postgres:///$TARGET_DB serve-http &> 
revocation-bank.log &
+taler-exchange-httpd -c $CONF 2> taler-exchange-httpd.log &
+EXCHANGE_PID=$!
+taler-merchant-httpd -c $CONF -L INFO 2> taler-merchant-httpd.log &
+MERCHANT_PID=$!
+taler-exchange-wirewatch -c $CONF 2> taler-exchange-wirewatch.log &
+taler-auditor-httpd -c $CONF 2> taler-auditor-httpd.log &
+
+# Wait for all bank to be available (usually the slowest)
+for n in `seq 1 50`
+do
+    echo -n "."
+    sleep 0.2
+    OK=0
+    # bank
+    wget http://localhost:8082/ -o /dev/null -O /dev/null >/dev/null || 
continue
+    OK=1
+    break
+done
+# Wait for all other services to be available
+for n in `seq 1 50`
+do
+    echo -n "."
+    sleep 0.1
+    OK=0
+    # exchange
+    wget http://localhost:8081/ -o /dev/null -O /dev/null >/dev/null || 
continue
+    # merchant
+    wget http://localhost:9966/ -o /dev/null -O /dev/null >/dev/null || 
continue
+    # Auditor
+    wget http://localhost:8083/ -o /dev/null -O /dev/null >/dev/null || 
continue
+    OK=1
+    break
+done
+
+
+if [ 1 != $OK ]
+then
+    kill `jobs -p`
+    wait
+    exit_skip "Failed to launch services"
+fi
+echo " DONE"
+
+# run wallet CLI
+echo "Running wallet"
+taler-wallet-cli --wallet-db=$WALLET_DB --no-throttle \
+                 testing withdraw \
+                 -e $EXCHANGE_URL \
+                 -b $BANK_URL \
+                 -a TESTKUDOS:8
+
+
+export coins=$(taler-wallet-cli --wallet-db=$WALLET_DB advanced dump-coins)
+
+# Find coin we want to revoke
+export rc=$(echo "$coins" | jq -r '[.coins[] | select((.denom_value == 
"TESTKUDOS:2"))][0] | .coin_pub')
+# Find the denom
+export rd=$(echo "$coins" | jq -r '[.coins[] | select((.denom_value == 
"TESTKUDOS:2"))][0] | .denom_pub_hash')
+echo "Revoking denomination ${rd} (to affect coin ${rc})"
+# Find all other coins, which will be suspended
+export susp=$(echo "$coins" | jq --arg rc "$rc" '[.coins[] | select(.coin_pub 
!= $rc) | .coin_pub]')
+
+# Do the revocation
+taler-exchange-keyup -o e2a2.dat -c $CONF -r $rd
+taler-auditor-sign -c $CONF -u $AUDITOR_URL -r e2a2.dat -o a2e2.dat -m 
$MASTER_PUB
+rm e2a2.dat
+mv a2e2.dat $ABD
+
+# Restart the exchange...
+kill -SIGUSR1 $EXCHANGE_PID
+sleep 1 # Give exchange time to re-scan data
+echo "Restarted the exchange post revocation"
+
+# Now we suspend the other coins, so later we will pay with the recouped coin
+taler-wallet-cli --wallet-db=$WALLET_DB advanced suspend-coins "$susp"
+
+# Update exchange /keys so recoup gets scheduled
+taler-wallet-cli --wallet-db=$WALLET_DB exchanges update \
+                 -f $EXCHANGE_URL
+
+# Block until scheduled operations are done
+taler-wallet-cli --wallet-db=$WALLET_DB run-until-done
+
+# Now we buy something, only the coins resulting from recouped will be
+# used, as other ones are suspended
+taler-wallet-cli --wallet-db=$WALLET_DB testing test-pay \
+                 -m $MERCHANT_URL -k sandbox \
+                 -a "TESTKUDOS:1" -s "foo"
+taler-wallet-cli --wallet-db=$WALLET_DB run-until-done
+
+echo "Purchase with recoup'ed coin (via reserve) done"
+
+# Find coin we want to refresh, then revoke
+export rrc=$(echo "$coins" | jq -r '[.coins[] | select((.denom_value == 
"TESTKUDOS:5"))][0] | .coin_pub')
+# Find the denom
+export zombie_denom=$(echo "$coins" | jq -r '[.coins[] | select((.denom_value 
== "TESTKUDOS:5"))][0] | .denom_pub_hash')
+
+echo "Will refresh coin ${rrc} of denomination ${zombie_denom}"
+# Find all other coins, which will be suspended
+export susp=$(echo "$coins" | jq --arg rrc "$rrc" '[.coins[] | 
select(.coin_pub != $rrc) | .coin_pub]')
+
+export rrc
+export zombie_denom
+
+# Travel into the future! (must match DURATION_WITHDRAW option)
+export TIMETRAVEL="--timetravel=604800000000"
+
+echo "Launching exchange 1 week in the future"
+kill -TERM $EXCHANGE_PID
+taler-exchange-httpd $TIMETRAVEL -c $CONF 2> taler-exchange-httpd.log &
+export EXCHANGE_PID=$!
+
+# Wait for exchange to be available
+for n in `seq 1 50`
+do
+    echo -n "."
+    sleep 0.1
+    OK=0
+    # exchange
+    wget http://localhost:8081/ -o /dev/null -O /dev/null >/dev/null || 
continue
+    OK=1
+    break
+done
+
+echo "Refreshing coin $rrc"
+taler-wallet-cli $TIMETRAVEL --wallet-db=$WALLET_DB advanced force-refresh 
"$rrc"
+taler-wallet-cli $TIMETRAVEL --wallet-db=$WALLET_DB run-until-done
+
+# Update our list of the coins
+export coins=$(taler-wallet-cli $TIMETRAVEL --wallet-db=$WALLET_DB advanced 
dump-coins)
+
+# Find resulting refreshed coin
+export freshc=$(echo "$coins" | jq -r --arg rrc "$rrc" \
+  '[.coins[] | select((.refresh_parent_coin_pub == $rrc) and .denom_value == 
"TESTKUDOS:0.1")][0] | .coin_pub'
+)
+
+# Find the denom of freshc
+export fresh_denom=$(echo "$coins" | jq -r --arg rrc "$rrc" \
+  '[.coins[] | select((.refresh_parent_coin_pub == $rrc) and .denom_value == 
"TESTKUDOS:0.1")][0] | .denom_pub_hash'
+)
+
+echo "Coin ${freshc} of denomination ${fresh_denom} is the result of the 
refresh"
+
+# Find all other coins, which will be suspended
+export susp=$(echo "$coins" | jq --arg freshc "$freshc" '[.coins[] | 
select(.coin_pub != $freshc) | .coin_pub]')
+
+
+# Do the revocation of freshc
+echo "Revoking ${fresh_denom} (to affect coin ${freshc})"
+taler-exchange-keyup -c $CONF -o e2a3.dat -r $fresh_denom
+taler-auditor-sign -c $CONF -u $AUDITOR_URL -r e2a3.dat -o a2e3.dat -m 
$MASTER_PUB
+rm e2a3.dat
+mv a2e3.dat $ABD
+
+# Restart the exchange...
+kill -SIGUSR1 $EXCHANGE_PID
+sleep 1 # give exchange time to re-scan data
+
+
+# Now we suspend the other coins, so later we will pay with the recouped coin
+taler-wallet-cli $TIMETRAVEL --wallet-db=$WALLET_DB advanced suspend-coins 
"$susp"
+
+# Update exchange /keys so recoup gets scheduled
+taler-wallet-cli $TIMETRAVEL --wallet-db=$WALLET_DB exchanges update \
+                 -f $EXCHANGE_URL
+
+# Block until scheduled operations are done
+taler-wallet-cli $TIMETRAVEL --wallet-db=$WALLET_DB run-until-done
+
+echo "Restarting merchant (so new keys are known)"
+kill -TERM $MERCHANT_PID
+taler-merchant-httpd -c $CONF -L INFO 2> taler-merchant-httpd.log &
+MERCHANT_PID=$!
+# Wait for merchant to be again available
+for n in `seq 1 50`
+do
+    echo -n "."
+    sleep 0.1
+    OK=0
+    # merchant
+    wget http://localhost:9966/ -o /dev/null -O /dev/null >/dev/null || 
continue
+    OK=1
+    break
+done
+
+# Now we buy something, only the coins resulting from recoup+refresh will be
+# used, as other ones are suspended
+taler-wallet-cli $TIMETRAVEL --wallet-db=$WALLET_DB testing test-pay \
+                 -m $MERCHANT_URL -k sandbox \
+                 -a "TESTKUDOS:0.02" -s "bar"
+taler-wallet-cli $TIMETRAVEL --wallet-db=$WALLET_DB run-until-done
+
+echo "Bought something with refresh-recouped coin"
+
+echo "Shutting down services"
+kill `jobs -p`
+wait
+
+# clean up
+echo "Final clean up (disabled)"
+dropdb $TARGET_DB
+rm -r $DATA_DIR || true
+rm $CONF
+rm -r $TMP_DIR
+
+exit 0

-- 
To stop receiving notification emails like this one, please contact
address@hidden.



reply via email to

[Prev in Thread] Current Thread [Next in Thread]